from django.urls import path, re_path
from . import views

app_name = 'metabaseEditor'

project_url = r'^project/(?P<project_id>[^/]+)/'
experiement_url = r'experiment/(?P<submission_file_id>[^/]+)'
sequencing_url = r'sequencing/(?P<sequencing_file_id>[^/]+)'

urlpatterns = [
    re_path(r'^project/create$',
        views.create_project,
        name='create_project'),
    re_path(r'^project(?:/(?P<project_id>[0-9]+))?/$',
        views.manage_project,
        name='manage_project'),
    re_path(r'^project/load_project$',
        views.load_project,
        name='load_project'),
    re_path(project_url + r'delete$',
        views.delete_project,
        name='delete_project'),
    re_path(r'^project(?:/(?P<project_id>[0-9]+))?/users/get$',
        views.get_project_users,
        name='get_project_users'),

    re_path(project_url + r'subproject/delete/information$',
        views.project.get_delete_info_subproject,
        name='get_delete_info_subproject'),
    re_path(project_url + r'experiment-file/delete/information$',
        views.project.get_delete_info_submission_file,
        name='get_delete_project_info_submission_file'),
    re_path(project_url + r'libraries/delete/information$',
        views.project.get_delete_info_libraries,
        name='get_delete_project_info_libraries'),
    re_path(project_url + r'tubes/delete/information$',
        views.project.get_delete_info_tubes,
        name='get_delete_project_info_tubes'),
    re_path(project_url + r'plates/delete/information$',
        views.project.get_delete_info_plates,
        name='get_delete_project_info_plates'),
    re_path(project_url + r'samples/delete/information$',
        views.project.get_delete_info_samples,
        name='get_delete_project_info_samples'),
    re_path(project_url + r'extracts/delete/information$',
        views.project.get_delete_info_extracts,
        name='get_delete_project_info_extracts'),

    re_path(project_url + r'experiment_list$',
        views.project.get_deleted_submission_files,
        name='get_deleted_submission_files'),
    re_path(project_url + r'delete/identify$',
        views.project.identify_deleted_project,
        name='identify_deleted_project'),
    re_path(r'^project(?:/(?P<project_id>[0-9]+))?/write_delete_messages$',
        views.write_delete_messages,
        name='write_delete_messages'),

    re_path(project_url + r'parent-project/delete/identify$',
        views.project.identify_deleted_parent_project,
        name='identify_deleted_parent_project'),
    re_path(project_url + r'parent-project/delete$',
        views.project.delete_parent_project,
        name='delete_parent_project'),

    re_path(project_url + 'information/update$',
        views.update_project_information,
        name='update_project_information'),
    re_path(r'^project(?:/(?P<project_id>[0-9]+))?/experiment/get_data$',
        views.get_project_experiment,
        name='get_project_experiment'),
    re_path("^project/[0-9]+/" + experiement_url + r'/download$',
        views.export_submission_file,
        name='download_experiment'),

    re_path(project_url + r'file/import/check$',
        views.check_file_import,
        name='check_file_import'),
    re_path(project_url + r'samples/import/check$',
        views.check_samples_import,
        name='check_samples_import'),
    re_path(project_url + r'extracts/import/check$',
        views.check_extracts_import,
        name='check_extracts_import'),
    re_path(project_url + r'controls/import/check$',
        views.check_controls_import,
        name='check_controls_import'),
    re_path(project_url + r'pcrs/import/check$',
        views.check_pcrs_import,
        name='check_pcrs_import'),
    re_path(project_url + r'plates/import/check$',
        views.check_plates_import,
        name='check_plates_import'),
    re_path(project_url + r'tubes/import/check$',
        views.check_tubes_import,
        name='check_tubes_import'),
    re_path(project_url + r'write_messages$',
        views.write_messages,
        name='check_write_messages'),
    re_path(project_url + r'import/check/clear$',
        views.remove_imported_data_on_fail,
        name='remove_imported_data_on_fail'),

    re_path(project_url + r'fileAndTube/import$',
        views.import_file_and_tube,
        name='import_file_and_tube'),
    re_path(project_url + r'pcr_plates/import$',
        views.import_pcr_plate,
        name='import_pcr_plate'),
    re_path(project_url + r'samples/import$',
        views.import_samples,
        name='import_samples'),
    re_path(project_url + r'extracts/import$',
        views.import_extracts,
        name='import_extracts'),

    re_path(project_url + r'fileAndTube/import/remove$',
        views.remove_file_tube_on_fail,
        name='remove_file_and_tube_on_fail'),
    re_path(project_url + r'pcr_plates/import/remove$',
        views.remove_plate_on_fail,
        name='remove_pcr_plate_on_fail'),
    re_path(project_url + r'samples/import/remove$',
        views.remove_samples_on_fail,
        name='remove_samples_on_fail'),
    re_path(project_url + r'extracts/import/remove$',
        views.remove_extracts_on_fail,
        name='remove_extracts_on_fail'),

    re_path(project_url + r'unlink_tube_and_pcrs$',
        views.project.unlink_pcr_tube,
        name='unlink_tube_submission_file'),
    re_path(project_url + r'unlink_project_tube$',
        views.project.unlink_project_tube,
        name='unlink_project_tube'),
    re_path(project_url + r'remove_project_tube$',
        views.project.remove_project_tube_wo_lib,
        name='remove_project_tube_wo_lib'),

    re_path("^project/[0-9]+/" + experiement_url + r'/libraries/delete/information$',
        views.experiment.get_delete_info_libraries,
        name='get_delete_info_libraries'),
    re_path("^project/[0-9]+/" + experiement_url + r'/tubes/delete/information$',
        views.experiment.get_delete_info_tubes,
        name='get_delete_info_tubes'),
    re_path("^project/[0-9]+/" + experiement_url + r'/plates/delete/information$',
        views.experiment.get_delete_info_plates,
        name='get_delete_info_plates'),
    re_path("^project/[0-9]+/" + experiement_url + r'/samples/delete/information$',
        views.experiment.get_delete_info_samples,
        name='get_delete_info_samples'),
    re_path("^project/[0-9]+/" + experiement_url + r'/extracts/delete/information$',
        views.experiment.get_delete_info_extracts,
        name='get_delete_info_extracts'),

    re_path(project_url + experiement_url + r'/file/delete/identify$',
        views.experiment.identify_deleted_submission_file,
        name='identify_deleted_submission_file'),
    re_path("^project/[0-9]+/" + experiement_url + r'/tubes/delete/identify$',
        views.experiment.identify_deleted_tubes,
        name='identify_deleted_tubes'),
    re_path("^project/[0-9]+/" + experiement_url + r'/plates/delete/identify$',
        views.experiment.identify_deleted_plates_primers,
        name='identify_deleted_plates_primers'),
    re_path("^project/[0-9]+/" + experiement_url + r'/samples/delete/identify$',
        views.experiment.identify_deleted_samples,
        name='identify_deleted_samples'),
    re_path("^project/[0-9]+/" + experiement_url + r'/extracts/delete/identify$',
        views.experiment.identify_deleted_extracts,
        name='identify_deleted_extracts'),

    re_path(project_url + experiement_url + r'/file/delete$',
        views.experiment.delete_submission_file,
        name='delete_file'),
    re_path("^project/[0-9]+/" + experiement_url + r'/tubes/delete$',
        views.experiment.delete_tubes,
        name='delete_tubes'),
    re_path("^project/[0-9]+/" + experiement_url + r'/plates/delete$',
        views.experiment.delete_plates,
        name='delete_plates'),
    re_path("^project/[0-9]+/" + experiement_url + r'/samples/delete$',
        views.experiment.delete_samples,
        name='delete_samples'),
    re_path("^project/[0-9]+/" + experiement_url + r'/controls/delete$',
        views.experiment.delete_controls,
        name='delete_controls'),
    re_path("^project/[0-9]+/" + experiement_url + r'/primers/delete$',
        views.experiment.delete_primers,
        name='delete_primers'),

    re_path(project_url + experiement_url + r'/unlink_tube_and_pcrs$',
        views.experiment.unlink_pcr_tube,
        name='unlink_tube_submission_file'),
    re_path(project_url + experiement_url + r'/unlink_exp_tube$',
        views.experiment.unlink_tube_submission_file,
        name='unlink_tube_submission_file'),
    re_path(project_url + experiement_url + r'/remove_exp_tube$',
        views.experiment.remove_exp_tube_wo_lib,
        name='remove_exp_tube_wo_lib'),

    re_path(r'^sequencing/?$',
        views.manage_sequencing,
        name='manage_sequencing'),
    re_path(r'^project(?:/(?P<project_id>[0-9]+))?/sequencing/get_data$',
        views.get_project_sequencing,
        name='get_project_sequencing'),
    re_path(sequencing_url + r'/information$',
        views.sequencing.get_information,
        name='get_sequencing_information'),
    re_path(project_url + r'get_library_and_tube_information$',
        views.get_library_and_tube_information,
        name='get_library_and_tube_information'),
    re_path(project_url + r'sequencing/library/link$',
        views.link_library,
        name='link_library'),
    re_path(project_url + r'library/unlink$',
        views.unlink_library,
        name='unlink_library'),
    re_path(project_url + r'sequencing/import$',
        views.add_sequencing,
        name='project_import_sequencing'),
    re_path(sequencing_url + r'/remove$',
        views.remove_sequencing,
        name='remove_sequencing'),
    re_path(r'^sequencing/get_sequencing_information$',
        views.get_sequencing_information, name='get_sequencing_information'),
    re_path(r'^sequencing/import/check$',
        views.check_sequencing_import,
        name='check_sequencing_import'),
    re_path(r'^sequencing/import$',
        views.import_sequencing,
        name='import_sequencing'),
]
